#This library enables to manage file paths in the System.
import os.path

#Tornado web Server libraries.
import tornado.httpserver
import tornado.ioloop
import tornado.options
import tornado.web


#Import the definitions.
from tornado.options import define, options
define("port", default=8000, help="Inicializa la aplicacion en el puerto especificado."
       , type=int)  #Ask for a port to connect. Default is 8000.

#Is tasked with rendering index.html
class IndexHandler(tornado.web.RequestHandler):
    def get(self):
        self.render('index.html')

#Collects the text from index.html and ends it to poem.html.
class SomeHandler(tornado.web.RequestHandler):
    def post(self):
        noun1 = self.get_argument('noun1')
        noun2 = self.get_argument('noun2')
        verb = self.get_argument('verb')
        noun3 = self.get_argument('noun3')
        self.render('poem.html',roads = noun1, wood = noun2, made = verb,
                    difference = noun3)

#Program's body.
if __name__ == '__main__':
    tornado.options.parse_command_line()
    #Generates the app.
    app = tornado.web.Application(handlers=[(r'/', IndexHandler),
                                            (r'/poem', SomeHandler)],
                                  template_path=os.path.join(os.path.dirname
                                                             (__file__),
                                                             "templates")) #os.path.joins loads an HTML template from a folder called "templates"
    http_server = tornado.httpserver.HTTPServer(app)
    http_server.listen(options.port)
    tornado.ioloop.IOLoop.instance().start()
